﻿
using System.Numerics;
using System.Runtime.CompilerServices;

nint x1 = 3;
nuint x2 = 4;

unsafe
{
    Console.WriteLine(sizeof(nint));
    Console.WriteLine(sizeof(nuint));
}

{
    IntPtr p1 = new IntPtr(5);
    IntPtr p2 = new IntPtr(6);

    // C# 11: OK
    // C# 10 or below: error CS0019: Operator '+' cannot be applied to operands of type 'IntPtr' and 'IntPtr'
    IntPtr p3 = p1 + p2;
    IntPtr p4 = p1 - p2;
    IntPtr p5 = p1 * p2;
    IntPtr p6 = p1 / p2;
    IntPtr p7 = p1 % p2;

    Console.WriteLine(p1 == p2);
    Console.WriteLine(p1 != p2);
    Console.WriteLine(p1 > p2);
    Console.WriteLine(p1 >= p2);
    Console.WriteLine(p1 < p2);
    Console.WriteLine(p1 <= p2);

    Console.WriteLine(p1 & p2);
    Console.WriteLine(p1 | p2);
    Console.WriteLine(p1 ^ p2);

    p1++;
    p1--;

    IntPtr p8 = -p1;
    IntPtr p9 = ~p1;
    IntPtr p10 = p1 << 2;
    IntPtr p11 = p1 >> 2;
    // IntPtr p12 = p1 >>> 2;

    int[] n = new int[500];
    Console.WriteLine(n[p1]);
}

{
    nint n1 = 5;
    nint n2 = 6;

    nint n3 = n1 + n2;
    nint n4 = n1 - n2;
    nint n5 = n1 * n2;
    nint n6 = n1 / n2;
}

IntPtr p = new nint(6); // C# 10 이하에서는 컴파일 오류

Console.WriteLine(nint.Zero);
Console.WriteLine(nuint.Zero);

Console.WriteLine(IntPtr.MaxValue);

GetNint();

nint GetNint()
{
    return default;
}